package dbc.r15.sample.dcjdbpr;

public class PrintLineWrapper {
	private final int[] PRT_BUFFER = {0, 80};
	private final int[] PRT_CITY = {0, 15};
	private final int[] PRT_FILLER01 = {15, 4};
	private final int[] PRT_NAME = {19, 24};
	private final int[] PRT_FILLER02 = {43, 4};
	private final int[] PRT_PAY = {49, 12};
	private final int[] PRT_FILLER03 = {61, 8};
	private final int[] PRT_TAXES = {69, 10};
	private final int[] PRT_FILLER04 = {79, 2};
		// Variable to hold the binary data in the container
		private byte[] pData;
		// Set the binary value of the container
		public void setByteArray(byte[] data) { pData = data;}
		// Get the binary value of the container
		public byte[] getByteArray() {return pData;}
		public String getBuffer() {return new String(pData, 0, pData.length - 1);
		}
		public void setBuffer(String newValue) {setNewValue(newValue, PRT_BUFFER[0], PRT_BUFFER[1]);
		}
		public void setCity(String newValue) {setNewValue(newValue, PRT_CITY[0], PRT_CITY[1]);
		}
		public void setName(String newValue) {setNewValue(newValue, PRT_NAME[0], PRT_NAME[1]);
		}
		public void setPay(String newValue) {setNewValueRJ(newValue, PRT_PAY[0], PRT_PAY[1]);
		}
		public void setTaxes(String newValue) {setNewValueRJ(newValue, PRT_TAXES[0], PRT_TAXES[1]);
		}
		private void setNewValue(String newValue, int index, int length) {
			/* 1. create a new byte array to hold the string called tData for temporary data
			 * 2. copy the new tData byte array to the cData byte array one byte at a time Left Justified
			 * 3. pad the cData with spaces up to the length passed in on the call 
			 */
			byte tData[] = newValue.getBytes();		// .step 1.
			int tDatalen = tData.length;
			int pDatalen = pData.length;
			int i = 0;
			while ( i < length && index < pDatalen)
			{
				if ( i < tDatalen )
					pData[index++] = tData[i];
				else
					pData[index++] = 0x40;			
				i++;
			}
		}
		private void setNewValueRJ(String newValue, int index, int length) {	
			/* 1. create a new byte array to hold the string called tData for temporary data
			 * 2. copy the new tData byte array to the cData byte array one byte at a time Right Justified
			 * 3. pad the cData with spaces up to the length passed in on the call 
			 */
			int oindex = index;						// save original index
			// initialize the print field to spaces 
			for (int i = 0; i < length; index++) {
				pData[index] = (byte)0x40;
				i++;
			}
				
			index = oindex;							// restore the index	
			byte tData[] = newValue.getBytes();		// .step 1.
			int tDatalen = tData.length;
			int pDatalen = pData.length;
			int diff = length - tDatalen;
			index = index + diff;
			int i = 0;
			while ( i < tDatalen && index < pDatalen)
			{
				if ( i < tDatalen )
					pData[index++] = tData[i];		
				i++;
		}
}
}